Index: trunk/src/VBox/Additions/common/crOpenGL/dri_drv.c
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/dri_drv.c	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/dri_drv.c	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  * --------------------------------------------------------------------
  *
Index: trunk/src/VBox/Additions/common/crOpenGL/dri_drv.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/dri_drv.h	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/dri_drv.h	(revision 20509)
@@ -9,6 +9,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/dri_glx.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/dri_glx.h	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/dri_glx.h	(revision 20509)
@@ -9,6 +9,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.c
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.c	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.c	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.h	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/fakedri_drv.h	(revision 20509)
@@ -9,6 +9,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/fakedri_glfuncsList.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/fakedri_glfuncsList.h	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/fakedri_glfuncsList.h	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/fakedri_glxfuncsList.h	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/feedback/feedback_context.c
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/feedback/feedback_context.c	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/feedback/feedback_context.c	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_getshaders.c
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_getshaders.c	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_getshaders.c	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_texture.c
===================================================================
--- trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_texture.c	(revision 20476)
+++ trunk/src/VBox/Additions/common/crOpenGL/pack/packspu_texture.c	(revision 20509)
@@ -8,6 +8,15 @@
  * Copyright (C) 2009 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 