Index: trunk/src/VBox/Devices/Storage/DevATA.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/DevATA.cpp	(revision 20566)
+++ trunk/src/VBox/Devices/Storage/DevATA.cpp	(revision 20567)
@@ -5400,5 +5400,5 @@
 }
 
-#ifndef IN_RING0
+#ifndef IN_RING0 /** @todo do this in ring-0 as well. */
 /**
  * Port I/O Handler for primary port range IN string operations.
@@ -5435,11 +5435,6 @@
         cbTransfer = cTransAvailable * cb;
 
-#ifdef IN_RC
-        for (uint32_t i = 0; i < cbTransfer; i += cb)
-            MMGCRamWriteNoTrapHandler((char *)GCDst + i, s->CTX_SUFF(pbIOBuffer) + s->iIOBufferPIODataStart + i, cb);
-#else /* !IN_RC */
         rc = PGMPhysSimpleDirtyWriteGCPtr(PDMDevHlpGetVMCPU(pDevIns), GCDst, s->CTX_SUFF(pbIOBuffer) + s->iIOBufferPIODataStart, cbTransfer);
         Assert(rc == VINF_SUCCESS);
-#endif /* IN_RC */
 
         if (cbTransfer)
@@ -5492,11 +5487,6 @@
         cbTransfer = cTransAvailable * cb;
 
-#ifdef IN_RC
-        for (uint32_t i = 0; i < cbTransfer; i += cb)
-            MMGCRamReadNoTrapHandler(s->CTX_SUFF(pbIOBuffer) + s->iIOBufferPIODataStart + i, (char *)GCSrc + i, cb);
-#else /* !IN_RC */
         rc = PGMPhysSimpleReadGCPtr(PDMDevHlpGetVMCPU(pDevIns), s->CTX_SUFF(pbIOBuffer) + s->iIOBufferPIODataStart, GCSrc, cbTransfer);
         Assert(rc == VINF_SUCCESS);
-#endif /* IN_RC */
 
         if (cbTransfer)
Index: trunk/src/VBox/VMM/PGMInternal.h
===================================================================
--- trunk/src/VBox/VMM/PGMInternal.h	(revision 20566)
+++ trunk/src/VBox/VMM/PGMInternal.h	(revision 20567)
@@ -449,11 +449,11 @@
         /** The HC virtual address of the two PAE page table. (i.e 1024 entries instead of 512) */
         R3PTRTYPE(PX86PTPAE)            paPaePTsR3;
-        /** The GC virtual address of the 32-bit page table. */
+        /** The RC virtual address of the 32-bit page table. */
         RCPTRTYPE(PX86PT)               pPTRC;
-        /** The GC virtual address of the two PAE page table. */
+        /** The RC virtual address of the two PAE page table. */
         RCPTRTYPE(PX86PTPAE)            paPaePTsRC;
-        /** The GC virtual address of the 32-bit page table. */
+        /** The R0 virtual address of the 32-bit page table. */
         R0PTRTYPE(PX86PT)               pPTR0;
-        /** The GC virtual address of the two PAE page table. */
+        /** The R0 virtual address of the two PAE page table. */
         R0PTRTYPE(PX86PTPAE)            paPaePTsR0;
     } aPTs[1];
@@ -484,5 +484,5 @@
     /** User argument for R0 handlers. */
     R0PTRTYPE(void *)                   pvUserR0;
-    /** Pointer to GC callback function. */
+    /** Pointer to RC callback function. */
     RCPTRTYPE(PFNPGMRCPHYSHANDLER)      pfnHandlerRC;
     /** User argument for RC handlers. */
Index: trunk/src/VBox/VMM/VMMAll/PGMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 20566)
+++ trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 20567)
@@ -2231,6 +2231,5 @@
                 return VINF_SUCCESS;
             }
-            else
-                LogFlow(("Out of sync entry %d\n", iPage));
+            LogFlow(("Out of sync entry %d\n", iPage));
         }
     }
@@ -2242,7 +2241,7 @@
      * Update the page tables.
      */
-    register unsigned iPage = pVM->pgm.s.iDynPageMapLast;
+    unsigned iPage = pVM->pgm.s.iDynPageMapLast;
     unsigned i;
-    for (i=0;i<(MM_HYPER_DYNAMIC_SIZE >> PAGE_SHIFT);i++)
+    for (i = 0; i < (MM_HYPER_DYNAMIC_SIZE >> PAGE_SHIFT); i++)
     {
         pVM->pgm.s.iDynPageMapLast = iPage = (iPage + 1) & ((MM_HYPER_DYNAMIC_SIZE >> PAGE_SHIFT) - 1);
Index: trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 20566)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 20567)
@@ -2146,5 +2146,4 @@
 }
 
-#ifndef IN_RC /* Ring 0 & 3 only. (Just not needed in GC.) */
 
 /**
@@ -2618,5 +2617,4 @@
 }
 
-#endif /* !IN_RC */
 
 /**